#include "Simon.h"

extern "C"
{
#include <os.h>
}

Simon::Simon()
{
	Initialize();//Note be sure you seeded rand
}

void Simon::Initialize()
{
	m_nCurrentLength =1;
	m_nLocation = 0;
	m_eGameStatus = GameInProgress;
	for(int i=0; i<MAX_SEQUENCE_LENGTH; i++)
		m_arrSequence[i] = (SimonColor)(rand() % 4);
}

int Simon::GetSequenceLength() const
{
	return m_nCurrentLength;
}

int Simon::GetCurrentLocation() const
{
	return m_nLocation;
}

SimonColor Simon::GetIndexColor(int i) const
{
	return m_arrSequence[i];
}

void Simon::StartSequence()
{
	m_nLocation = 0;
}

void Simon::TookTooLong()
{
	m_eGameStatus = YouTookTooLong;
}

bool Simon::Touched(SimonColor c)
{
	if( c == GetIndexColor(m_nLocation) )
	{
		m_nLocation++;
		if( m_nLocation >= m_nCurrentLength )
		{
			m_nCurrentLength++;
			if( m_nCurrentLength > MAX_SEQUENCE_LENGTH )
			{
				m_eGameStatus = YouWon;
			}
			return false;
		}
		return true;
	}
	
	m_eGameStatus = YouPressedWrongButton;
	return false;
}

bool Simon::IsGameOver() const { return m_eGameStatus != GameInProgress; }
bool Simon::DidWrongButton() const { return m_eGameStatus == YouPressedWrongButton; }
bool Simon::DidTakeTooLong() const { return m_eGameStatus == YouTookTooLong; }
bool Simon::DidWin() const { return m_eGameStatus == YouWon; }

